/******************************************************************************
 * FILE PURPOSE:     - LED HAL module Header
 ******************************************************************************
 * FILE NAME:     led_hal.h
 *
 * DESCRIPTION:    LED HAL API's.
 *
 * REVISION HISTORY:
 * 11 Oct 03 - PSP TII
 *
 * (C) Copyright 2002, Texas Instruments, Inc
 *******************************************************************************/

#ifndef __LED_HAL__
#define __LED_HAL__

/* Interface prototypes */
#define ACTION_TEC
int avalanche_led_hal_init (int *gpio_off_value, int num_gpio_pins);
int avalanche_led_config_set (LED_CONFIG_T * led_cfg);
int avalanche_led_config_get (LED_CONFIG_T *led_cfg,int module_id,int instance, int state);
void *avalanche_led_register (const char *module_name, int instance_num);
void  avalanche_led_action (void *handle, int state_id);
#ifdef ACTION_TEC
void *avalanche_led_register_new (const char *module_name, int instance_num); 
void  avalanche_led_action_new (void *handle, int state_id);
#ifdef ACTION_TEC_VERIZON_WRA
void avalanche_led_action_standby (void *module, int state_id, int on);
void set_standby(int standby);
int get_standby(void);
#endif
void set_dslshowtime (int state);
int get_dslshowtime (void);
void set_ipup (int ipup);
int get_ipup (void);
#endif //ACTION_TEC
int avalanche_led_unregister (void *handle);
void avalanche_led_free_all(void);
void avalanche_led_hal_exit (void);

#endif /*__LED_HAL__ */
