#! /usr/bin/perl
###############################################################################
###############################################################################
#
# To remove comments from C++ & Perl source files
#
#			Version 2
#
#	by Andrew Hardwick, http://duramecho.com, 2001/12/4 - 2002/4/10
#
#	Released under GNU Public Licence.
#
###############################################################################
###############################################################################
#
# How To Use
#
# It takes one command-line parameter, the directory to use.
#
###############################################################################
###############################################################################

# Include libraries
use File::Find;		# For file finding command
# Disenable automatic global variables
use strict;

###############################################################################
# Main routine
###############################################################################

# Get directory name (from command line)
unless($ARGV[0])
{	die("Error: No directory specified.\n");}
my $Directory=$ARGV[0];
# Find all source files (store names indexed by path)
my %Files;
find(sub
	{	if(/.*\.(c|h|cpp|pl)$/i)	# grab source & txt files
		{	unless($_ eq 'Combined.txt') # skip the output file
			{	$Files{$File::Find::name}=$_;}}},
	$Directory);
# Process all the files
my $Text;
foreach my $FromFilePath (keys %Files)
{	print "Processing $Files{$FromFilePath}\n";
	# Get text from file
	open(FILETOREAD,'<'.$FromFilePath)||
			die("Cannot open $FromFilePath to read.");
	read FILETOREAD,$Text,-s $FromFilePath;
	close FILETOREAD;
	if($FromFilePath=~/.pl$/)	# Perl
	{	# Remove single line comments
		$Text=~s/\#.*?\n/\n/g;}
	else	# C++
	{	# Remove multiple line comments
		$Text=~s/\/\*.*?\*\///sg;
		# Remove single line comments
		$Text=~s/\/\/.*?\n/\n/g;}
	# Remove bank lines
	$Text=~s/^\s*\n//mg;
	# Write text to file
	open(FILETOWRITE,'>'.$FromFilePath)||
			die("Cannot open $FromFilePath to write.");
	print FILETOWRITE $Text;
	close FILETOWRITE;}
